#!/bin/bash
#

source /backups/patch/settings.sh

heading() {
 clear
 echo "${inv} Swivel Maintenance (c) $COPYRIGHT_YEAR${nor}
            ${inv}$PINSAFE_TYPE${nor}"
 echo
 echo $1
 echo
}

s_heading() {
 clear
 echo "${inv} Swivel Maintenance (c) $COPYRIGHT_YEAR${nor}
            ${inv}$PINSAFE_TYPE${nor}"
 echo
}

yorn() {
 echo
 echo -n "Are you sure? (Yes/No): "
 read yn
 check_ans $1 $yn
}

check_ans() {
 if test ! $2; then
  $1; fi
 if test ! $2 = "Yes" && test ! $2 = "yes" && test ! $2 = "y" && test ! $2 = "Y" ; then
  $1; fi
}

get_patch_ver() {
 PATCH_VER_ORIG=`grep APPLIANCE_PATCH_VER /etc/pinsafe.conf|cut -d\= -f2`
 patch_ver_new=`echo $PATCH_VER|cut -d\. -f3`
 patch_ver_existing=`grep APPLIANCE_PATCH_VER /etc/pinsafe.conf|cut -d\. -f3`
}

update_patch_ver() {
 sed -i "s/APPLIANCE_PATCH_VER=$PATCH_VER_ORIG/APPLIANCE_PATCH_VER=$PATCH_VER/g" /etc/pinsafe.conf
}

test_patch_ver(){
 p1=`expr $patch_ver_existing + 1`

 if test $patch_ver_new -le $patch_ver_existing; then
  echo "This patch has already been applied."
  echo
  echo "   Current patch level of appliance: $PATCH_VER_ORIG"
  echo "   Patch version: $PATCH_VER"
  echo
  read -p "Press Return to exit"
  exit; fi

 if test $p1 -gt $patch_ver_new; then
  echo "The applaince patch version is newer than the patch you are trying to apply."
  echo
  echo "   Current patch level of appliance: $PATCH_VER_ORIG"
  echo "   Patch version: $PATCH_VER"
  echo
  read -p "Press Return to exit"
  exit; fi

 if test $p1 -lt $patch_ver_new; then
  echo "Please apply the previous patches before applying this patch. Existing patch"
  echo "level is too low:"
  echo
  echo "   Current patch level of appliance: $PATCH_VER_ORIG"
  echo "   Patch version: $PATCH_VER"
  echo
  read -p "Press Return to exit"
  exit; fi
}

# Create update routine. Use Standard calls above.

commands() {
 appliance_ver
 if test $rpmcount -eq 3; then
  upgrade_appliance
  set_values
 else
  appliance_version_erorr
  echo; read -p "Press Return to continue" yn
  exit
 fi
}

appliance_ver() {
 echo; echo -n "Checking appliance version."
 rpmcount=0
 if test `rpm -qa email` = "email-3.1.2-1.RHEL4"; then
   ((rpmcount = rpmcount + 1))
   echo -n "."; fi
 if test `rpm -qa MegaCli` = "MegaCli-2.00.12-1"; then
  ((rpmcount = rpmcount + 1))
   echo -n "."; fi
 if test `rpm -qa webmin` = "webmin-1.510-1"; then
  ((rpmcount = rpmcount + 1))
   echo "."; fi
}

appliance_version_erorr() {
 echo
 echo "The appliance version requires upgrading. Please download patch file"
 echo "$PATCH_VER.appliance.full and apply it."
 echo
}

upgrade_appliance() {
 echo; echo "Creating backup of original appliance files to /tmp"
 tar cfz /tmp/appliance.backup.tar.gz /usr/local/bin/* 2>/dev/null

 if test -s /tmp/appliance.backup.tar.gz; then
  echo; echo "Updating appliance"
  cp -rp bin/* /usr/local/bin
  echo; echo "Upgrade complete. Please exit the menu system and login again to access the"
  echo "new menus."
 else
  echo; echo "Unable to create backup of existing appliance. Exiting..."
 fi
}

set_values() {
 echo "APPLIANCE_PATCH_VER=2.0.7" > $PINSAFE_CONF_NEW
 cat $PINSAFE_CONF | grep -v ^APPLIANCE_PATCH_VER >> $PINSAFE_CONF_NEW
 cat $PINSAFE_CONF_NEW > $PINSAFE_CONF
 rm $PINSAFE_CONF_NEW
}

warning() {
# Check the patch should run before doing anything
 yorn exit

 heading "Upgrading Swivel"
 echo "Continuing will apply patch ${inv}$PATCH_VER${nor}. It is suggested that the system is not"
 echo "authenticating users whilst the patch is applied."
}

warning
commands
echo; read -p "Press Return to continue" yn
